extern sfr sbit SOFTWARE_W5100_SCS;
extern sfr sbit SOFTWARE_W5100_SDI;
extern sfr sbit SOFTWARE_W5100_SDO;
extern sfr sbit SOFTWARE_W5100_SCK;
extern sfr sbit SOFWTARE_W5100_RESET;

extern sfr sbit SOFTWARE_W5100_SCS_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SDI_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SDO_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SCK_DIRECTION;
extern sfr sbit SOFWTARE_W5100_RESET_DIRECTION;


#define WIZNET_WRITE_OPCODE 0xF0
#define WIZNET_READ_OPCODE 0x0F

#define MODE_REGISTER 0x0000

#define DEVICE_IP 0x000f//4 BYTES
#define SUBNET_MASK 0X0005//4 BYTES
#define GATE_WAY_ADDRESS 0X0001//4 BYTES
#define MAC 0X0009//6 BYTES

#define RX_MEMORY_SIZE_REGISTER 0x001A//1 BYTE
#define TX_MEMORY_SIZE_REGISTER 0x001B//1 BYTE

#define SOCKET0_MODE_REGISTER 0x0400
#define SOCKET0_CONTROL_REGISTER 0x0401

#define SOCKET0_STATUS_REGISTER 0x0403
#define SOCKET0_LOCAL_PORT 0x0404//2 BYTES
#define SOCKET0_DESTINATION_PORT 0x0410//2bytes
#define SOCKET0_DESTINATION_IP 0x040C//4 bytes
#define SOCKET0_DESTINATION_MAC 0x0406//6 BYTES
#define SOCKET0_TX_FREESIZE_REGISTER 0x0420//2 BYTES
#define SOCKET0_TX_WRITE_PTR 0x0424//2 BYTES
#define SOCKET0_RX_READ_PTR 0x0428//2 BYTES
#define SOCKET0_RECEIVESIZE_REGISTER 0x0426//2 BYTES

#define BASE_TX_BUFFER 0x4000
#define BASE_RX_BUFFER 0x6000


#define SOCKET0_MODE_REGISTER_TCP 0x01

#define SOCKET_CONTROL_REGISTER_OPEN 0x01
#define SOCKET_CONTROL_REGISTER_LISTEN 0x02
#define SOCKET_CONTROL_REGISTER_DISCONNECT 0x08
#define SOCKET_CONTROL_REGISTER_CLOSE 0x10
#define SOCKET_CONTROL_REGISTER_SEND 0x20
#define SOCKET_CONTROL_REGISTER_RECEIVE 0x40

#define SOCKET_CLOSED_STATUS 0x00
#define SOCKET_INIT_STATUS 0x13
#define SOCKET_LISTEN_STATUS 0x14
#define SOCKET_ESTABLISHED_STATUS 0x17

#define TX_BUF_MASK 0x07FF
#define RX_BUF_MASK 0x07FF
#define RX_TX_MALLOC 0x05

unsigned char Socket0;
extern void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength);
char _Remote_Ip_Address_[4];
char _Remote_Mac_Address_[6];

#include "SoftW5100Spi.c"
#include "SoftW5100.c"